/*
 * This file is part of tMCimg.
 * 
 * tMCimg is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PARALLEL_H
#define __PARALLEL_H

#include "config.h"

#if (HAVE_MPI_H) && (USE_MPI)
# include "mpi.h"
#else
# error "Cannot build parallel code without mpi.h"
#endif

#ifndef REALLY_RANDOM
#define REALLY_RANDOM 1
#endif

#define TAG_HISFILE 0x8887

#define MAX_HISTENT 1000

#define MPI_TWOPT ((sizeof(TWOPT_T) == 4) ? MPI_FLOAT : MPI_DOUBLE)

void initParallel(int *, char ***);
int isMaster(void);
int myNode(void);
int getNodeCount(void);
void parallel_savehis(const struct Config *, double, double, double,
                      double, double, double, double, float *);
void endParallel(void);

#endif /* __PARALLEL_H */

